=== debian/changelog ===
libzip (1.1.2-1.1) unstable; urgency=medium

  [ Hans-Christoph Steiner ]
  * Imported Upstream version 1.1.1
  * New upstream version (Closes: #662083)

  [ Ondřej Surý ]
  * Non-maintainer upload.
  * Imported Upstream version 1.1.2
  * Install NEWS as upstream changelog, README and TODO is no more

 -- Ondřej Surý <ondrej@debian.org>  Tue, 10 May 2016 12:09:23 +0200

libzip (1.0.1-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Upload Ubuntu version to Debian (Closes: #798747)
  * Stop building the ziptorrent; removed upstream. (Closes: #540992, #784684)
  * Bump standards version.

 -- Hans-Christoph Steiner <hans@eds.org>  Tue, 09 Feb 2016 20:48:46 +0100
