=== debian/changelog ===
libzip (1.5.1-0ubuntu1) disco; urgency=medium

  * New upstream release (LP: #1674057) (Closes: #894813)
    - Removes custom AES implementation in favour of using standard crypto libs
  * Build with cmake, autotools support was dropped.
  * Bump debhelper to compat 11
  * debian/control
    - Add Build-dep on libssl-dev and libbz2-dev
  * debian/libzip5.symbols: Update with new symbols
  * debian/rules:
    - Clean up Multi-arch support
    - set dh_missing to --fail-missing
    - Drop flags obsolete with dh 11
    - Strip -Bsymbolic-functions link flag as it causes test failures
  * debian/libzip-dev.install: don't install static lib, its not built now 
  * debian/libzip5.lintian-overrides:
    -  override possible-gpl-code-linked-with-openssl, libzip is BSD licensed
       only the debian packaging is licensed under GPLv3
  * debian/copyright: Update to reflect removed code

 -- Tim Lunn <tim@feathertop.org>  Tue, 27 Nov 2018 10:51:36 +1000

libzip (1.3.2-1) experimental; urgency=medium

  * Update to upstream version 1.3.2 (Closes: #881877)
  * Updated symbols file
  * Updated libzip-dev.install and rules to cover the new path of zipconf.h
  * Changed rules file to fix sets-dpkg-architecture-variable lintian warning

 -- Stefan Schörghofer <amd1212@4md.gr>  Mon, 20 Nov 2017 21:39:26 +0100

libzip (1.3.0+dfsg.1-1) experimental; urgency=medium

  * Updated to Upstream version 1.3.0 (Closes: #874010)
  * Changed Maintainer to Stefan Schörghofer (Closes: #879387)
  * libzip soname change (libzip4 -> libzip5)
  * Update symbols file
  * Added mandoc to Build-Depends
  * Bump standards version
  * changed watch uri to https
  * added gladman-fcrypt copyright to debian/copyright file
  * Removed docs/appnote.txt because it conflicts with DFSG
  * Added README.source file with build instructions

 -- Stefan Schörghofer <amd1212@4md.gr>  Mon, 30 Oct 2017 23:05:39 +0100

libzip (1.1.3-1) unstable; urgency=medium

  * Imported Upstream version 1.1.3
  * Add myself to Uploaders
  * Bump standards version (no change)
  * Rewrap with wrap-and-sort -a for better readability
  * Upstream changelog got renamed to NEWS.md
  * Install README.md and TODO.md into the packages again

 -- Ondřej Surý <ondrej@debian.org>  Sat, 31 Dec 2016 15:03:01 +0100
