=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Linking with -Bsymbolic-functions causes test failures
export DEB_LDFLAGS_MAINT_STRIP = -Wl,-Bsymbolic-functions

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_INSTALL_LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)


override_dh_installchangelogs:
	dh_installchangelogs NEWS.md

override_dh_missing:
	dh_missing --fail-missing
