=== debian/watch ===
version=3
https://www.nih.at/libzip/libzip-(.*)\.tar\.gz
