=== debian/changelog ===
libzip (1.5.1.8-1+eagle) unstable; urgency=low

  * ['Autobuild release-candidate: 0ca59716fe0d1d66bc8d79b9e3615fba1bccba3b']

 -- shuttle <shuttle@deepin.com>  Fri, 18 Sep 2020 09:05:53 +0000
