## libzip 1.5.2

=== debian/changelog ===
libzip (1.5.2-1) unstable; urgency=medium

  [ Ondřej Surý ]
  * Drop --with autoreconf, not needed with debhelper v12 compat
  and libzip uses cmake

  [ Stefan Schoerghofer ]
  * New upstream version 1.5.2 (Closes: #939474)
  * Refreshing patches

 -- Stefan Schörghofer <amd1212@4md.gr>  Fri, 22 Nov 2019 14:43:32 +0100

libzip (1.5.1-4) unstable; urgency=high

  * Add patch to fix serious bug in the AES encryption.

 -- Ondřej Surý <ondrej@debian.org>  Mon, 18 Mar 2019 08:10:42 +0000

libzip (1.5.1-3) unstable; urgency=medium

  [ Bernd Zeimetz ]
  * Create .gitlab-ci.yml file
  * Update debian/.gitlab-ci.yml Deleted .gitlab-ci.yml

  [ Stefan Schörghofer ]
  * Fixed Lintian warnings
  * Added lintian-ignore for possible-gpl-code-linked-with-openssl
    License is fine, GPL is coming from /debian
  * Removed gladman-fcrypt from /debian/copyright, not used anymore
  * Adopted /debian/README.source
  * Corrected my email Address in control

 -- Stefan Schörghofer <amd1212@4md.gr>  Tue, 22 Jan 2019 21:06:19 +0100

libzip (1.5.1-2) experimental; urgency=medium

  * Reintroduce dummy zip_archive_set_tempdir function to lower the SONAME
    back to libzip.so.4
  * Revert the soname change back to libzip4
  * Add Bernd and Stefan as co-maintainers

 -- Ondřej Surý <ondrej@debian.org>  Tue, 22 Jan 2019 18:13:16 +0000

libzip (1.5.1-1) experimental; urgency=medium

  * Just take over the orphaned package, Stefan Schörghofer is welcome
    to join the packaging team if he wants.
  * Update Vcs-* links and upstream URL
  * Upstream dropped static library, remove it from package for a moment
  * Add libbz2-dev and libssl-dev to libzip Build-Deps
  * s/API-CHANGES/API-CHANGES.md/
  * Update symbols file
  * Update watch file
  * New upstream version 1.5.1

 -- Ondřej Surý <ondrej@debian.org>  Sat, 19 Jan 2019 06:33:51 +0000
